diff --git a/src/main/java/net/minecraft/client/render/entity/LightningBoltRenderer.java b/src/main/java/net/minecraft/client/render/entity/LightningBoltRenderer.java
index a90031aa6..c5e7a88dc 100644
--- a/src/main/java/net/minecraft/client/render/entity/LightningBoltRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/LightningBoltRenderer.java
@@ -16,19 +16,19 @@ public class LightningBoltRenderer extends EntityRenderer<LightningEntity>
     {
     }
 
-    public void func_27002_a(LightningEntity lightningBolt, double d, double d1, double d2,
-                             float f, float f1)
+    @Override
+    public void render(Tessellator tessellator, LightningEntity lightning, double x, double y, double z,
+                       float yaw, float partialTick)
     {
-        Tessellator tessellator = Tessellator.instance;
         GL11.glDisable(GL11.GL_TEXTURE_2D);
         GL11.glDisable(GL11.GL_LIGHTING);
         GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(770, 1);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
         double ad[] = new double[8];
         double ad1[] = new double[8];
         double d3 = 0.0D;
         double d4 = 0.0D;
-        Random random = new Random(lightningBolt.seed);
+        Random random = new Random(lightning.seed);
         for(int j = 7; j >= 0; j--)
         {
             ad[j] = d3;
@@ -39,7 +39,7 @@ public class LightningBoltRenderer extends EntityRenderer<LightningEntity>
 
         for(int i = 0; i < 4; i++)
         {
-            Random random1 = new Random(lightningBolt.seed);
+            random.setSeed(lightning.seed);
             for(int k = 0; k < 3; k++)
             {
                 int l = 7;
@@ -60,30 +60,30 @@ public class LightningBoltRenderer extends EntityRenderer<LightningEntity>
                     double d8 = d6;
                     if(k == 0)
                     {
-                        d5 += random1.nextInt(11) - 5;
-                        d6 += random1.nextInt(11) - 5;
+                        d5 += random.nextInt(11) - 5;
+                        d6 += random.nextInt(11) - 5;
                     } else
                     {
-                        d5 += random1.nextInt(31) - 15;
-                        d6 += random1.nextInt(31) - 15;
+                        d5 += random.nextInt(31) - 15;
+                        d6 += random.nextInt(31) - 15;
                     }
                     tessellator.startDrawing(5);
                     float f2 = 0.5F;
                     tessellator.setColorRGBA_F(0.9F * f2, 0.9F * f2, 1.0F * f2, 0.3F);
-                    double d9 = 0.10000000000000001D + (double)i * 0.20000000000000001D;
+                    double d9 = 0.1D + (double)i * 0.2D;
                     if(k == 0)
                     {
-                        d9 *= (double)j1 * 0.10000000000000001D + 1.0D;
+                        d9 *= (double)j1 * 0.1D + 1.0D;
                     }
-                    double d10 = 0.10000000000000001D + (double)i * 0.20000000000000001D;
+                    double d10 = 0.1D + (double)i * 0.2D;
                     if(k == 0)
                     {
-                        d10 *= (double)(j1 - 1) * 0.10000000000000001D + 1.0D;
+                        d10 *= (double)(j1 - 1) * 0.1D + 1.0D;
                     }
                     for(int k1 = 0; k1 < 5; k1++)
                     {
-                        double d11 = (d + 0.5D) - d9;
-                        double d12 = (d2 + 0.5D) - d9;
+                        double d11 = (x + 0.5D) - d9;
+                        double d12 = (z + 0.5D) - d9;
                         if(k1 == 1 || k1 == 2)
                         {
                             d11 += d9 * 2D;
@@ -92,8 +92,8 @@ public class LightningBoltRenderer extends EntityRenderer<LightningEntity>
                         {
                             d12 += d9 * 2D;
                         }
-                        double d13 = (d + 0.5D) - d10;
-                        double d14 = (d2 + 0.5D) - d10;
+                        double d13 = (x + 0.5D) - d10;
+                        double d14 = (z + 0.5D) - d10;
                         if(k1 == 1 || k1 == 2)
                         {
                             d13 += d10 * 2D;
@@ -102,8 +102,8 @@ public class LightningBoltRenderer extends EntityRenderer<LightningEntity>
                         {
                             d14 += d10 * 2D;
                         }
-                        tessellator.addVertex(d13 + d5, d1 + (double)(j1 * 16), d14 + d6);
-                        tessellator.addVertex(d11 + d7, d1 + (double)((j1 + 1) * 16), d12 + d8);
+                        tessellator.addVertex(d13 + d5, y + (double)(j1 * 16), d14 + d6);
+                        tessellator.addVertex(d11 + d7, y + (double)((j1 + 1) * 16), d12 + d8);
                     }
 
                     tessellator.draw();
@@ -117,11 +117,4 @@ public class LightningBoltRenderer extends EntityRenderer<LightningEntity>
         GL11.glEnable(GL11.GL_LIGHTING);
         GL11.glEnable(GL11.GL_TEXTURE_2D);
     }
-
-    @Override
-    public void render(Tessellator tessellator, LightningEntity entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
-        func_27002_a(entity, x, y, z, yaw, partialTick);
-    }
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
index 4b184a97a..f4293f672 100644
--- a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
@@ -55,7 +55,7 @@ public class PlayerRenderer extends MobRenderer<Player>
         } else if (player.getGamemode() == Gamemode.spectator) {
             GL11.glColor4f(1f, 1f, 1f, 0.0f);
         }
-        ItemStack itemstack = player.inventory.armorItemInSlot(3);
+        ItemStack itemstack = player.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
         if(itemstack != null && itemstack.getItem().id < Block.blocksList.length)
         {
             GL11.glPushMatrix();
@@ -278,7 +278,7 @@ public class PlayerRenderer extends MobRenderer<Player>
 
     @Override
     protected boolean prepareArmor(Player entity, int layer, float partialTick) {
-        ItemStack itemstack = entity.inventory.armorItemInSlot(3 - layer);
+        ItemStack itemstack = entity.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD - layer);
         if(itemstack != null)
         {
             Item item = itemstack.getItem();
diff --git a/src/main/java/net/minecraft/client/render/model/SignModel.java b/src/main/java/net/minecraft/client/render/model/SignModel.java
index bacc3e4d8..7d3dfddaf 100644
--- a/src/main/java/net/minecraft/client/render/model/SignModel.java
+++ b/src/main/java/net/minecraft/client/render/model/SignModel.java
@@ -15,7 +15,7 @@ public class SignModel
         signStick.addBox(-1F, -2F, -1F, 2, 14, 2, 0.0F);
     }
 
-    public void func_887_a()
+    public void render()
     {
         signBoard.render(0.0625F);
         signStick.render(0.0625F);
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java b/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java
index 9cf491e4d..28ae55403 100644
--- a/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java
+++ b/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java
@@ -9,12 +9,14 @@ public class GuiTextureProperties {
     public final int width;
     public final int height;
     public final Border border;
+    public final boolean stretchInner;
 
-    public GuiTextureProperties(String type, int width, int height, Border border) {
+    public GuiTextureProperties(String type, int width, int height, Border border, boolean stretchInner) {
         this.type = type;
         this.width = width;
         this.height = height;
         this.border = border;
+        this.stretchInner = stretchInner;
     }
 
     public static class Border {
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTexturePropertiesAdapter.java b/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTexturePropertiesAdapter.java
index 08c7e3292..aca0a8e51 100644
--- a/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTexturePropertiesAdapter.java
+++ b/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTexturePropertiesAdapter.java
@@ -14,17 +14,32 @@ public class GuiTexturePropertiesAdapter implements JsonDeserializer<GuiTextureP
     @Override
     public GuiTextureProperties deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
         JsonObject jo = json.getAsJsonObject();
+        JsonObject scalingObj = jo.getAsJsonObject("scaling");
         String type = GuiTextureProperties.TYPE_STRETCH;
-        int width = jo.get("width").getAsInt();
-        int height = jo.get("height").getAsInt();
-        GuiTextureProperties.Border border = new GuiTextureProperties.Border(0);
+        boolean stretchInner = false;
+        int width = -1; // Required with TYPE_TILE or TYPE_NINE_SLICE
+        int height = -1; // Required with TYPE_TILE or TYPE_NINE_SLICE
+        GuiTextureProperties.Border border = null; // Required with TYPE_NINE_SLICE
 
-        if (jo.has("type")) {
-            type = jo.get("type").getAsString();
+        if (scalingObj.has("type")) {
+            type = scalingObj.get("type").getAsString();
         }
 
-        if (jo.has("border")) {
-            JsonElement be = jo.get("border");
+        if (type.equals(GuiTextureProperties.TYPE_TILE) || type.equals(GuiTextureProperties.TYPE_NINE_SLICE)) {
+            if (!scalingObj.has("width")) throw new JsonParseException("Gui scaling type 'tile' and 'nine_slice' requires a width property!");
+            if (!scalingObj.has("height")) throw new JsonParseException("Gui scaling type 'tile' and 'nine_slice' requires a height property!");
+
+            width = scalingObj.get("width").getAsInt();
+            height = scalingObj.get("height").getAsInt();
+        }
+
+        if (scalingObj.has("stretch_inner")) {
+            stretchInner = scalingObj.get("stretch_inner").getAsBoolean();
+        }
+
+        if (type.equals(GuiTextureProperties.TYPE_NINE_SLICE)) {
+            if (!scalingObj.has("border")) throw new JsonParseException("Gui scaling type 'nine_slice' requires a border property!");
+            JsonElement be = scalingObj.get("border");
             if (be.isJsonPrimitive()) {
                 border = new GuiTextureProperties.Border(be.getAsInt());
             } else if (be.isJsonObject()) {
@@ -37,7 +52,7 @@ public class GuiTexturePropertiesAdapter implements JsonDeserializer<GuiTextureP
             }
         }
 
-        return new GuiTextureProperties(type, width, height, border);
+        return new GuiTextureProperties(type, width, height, border, stretchInner);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/world/WorldClient.java b/src/main/java/net/minecraft/client/world/WorldClient.java
index a3d361827..f48ca5388 100644
--- a/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -79,14 +79,14 @@ public class WorldClient extends World {
         sendQueue.tick();
     }
 
-    public void func_711_c(int i, int j, int k, int l, int i1, int j1)
+    public void removePositionTypesInBounds(int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
     {
-        for(int k1 = 0; k1 < positionTypesList.size(); k1++)
+        for(int i = 0; i < positionTypesList.size(); i++)
         {
-            WorldBlockPositionType worldblockpositiontype = positionTypesList.get(k1);
-            if(worldblockpositiontype.x >= i && worldblockpositiontype.y >= j && worldblockpositiontype.z >= k && worldblockpositiontype.x <= l && worldblockpositiontype.y <= i1 && worldblockpositiontype.z <= j1)
+            WorldBlockPositionType worldblockpositiontype = positionTypesList.get(i);
+            if(worldblockpositiontype.x >= minX && worldblockpositiontype.y >= minY && worldblockpositiontype.z >= minZ && worldblockpositiontype.x <= maxX && worldblockpositiontype.y <= maxY && worldblockpositiontype.z <= maxZ)
             {
-                positionTypesList.remove(k1--);
+                positionTypesList.remove(i--);
             }
         }
 
@@ -111,28 +111,28 @@ public class WorldClient extends World {
     }
 
     @Override
-	public void scheduleBlockUpdate(int i, int j, int k, int l, int i1)
+	public void scheduleBlockUpdate(int x, int y, int z, int id, int delay)
     {
     }
 
     @Override
-	public boolean tickUpdates(boolean flag)
+	public boolean tickUpdates(boolean all)
     {
         return false;
     }
 
-    public void doPreChunk(int i, int j, boolean flag)
+    public void doPreChunk(int chunkX, int chunkZ, boolean playerAdded)
     {
-        if(flag)
+        if(playerAdded)
         {
-            chunkCache.prepareChunk(i, j);
+            chunkCache.prepareChunk(chunkX, chunkZ);
         } else
         {
-            chunkCache.func_539_c(i, j);
+            chunkCache.dropChunk(chunkX, chunkZ);
         }
-        if(!flag)
+        if(!playerAdded)
         {
-            markBlocksDirty(i * 16, 0, j * 16, i * 16 + 15, getHeightBlocks(), j * 16 + 15);
+            markBlocksDirty(chunkX * 16, 0, chunkZ * 16, chunkX * 16 + 15, getHeightBlocks(), chunkZ * 16 + 15);
         }
     }
 
@@ -251,7 +251,7 @@ public class WorldClient extends World {
 
     public boolean blockChange(int x, int y, int z, int id, int meta)
     {
-        func_711_c(x, y, z, x, y, z);
+        removePositionTypesInBounds(x, y, z, x, y, z);
         if(super.setBlockAndMetadata(x, y, z, id, meta))
         {
             notifyBlockChange(x, y, z, id);
@@ -265,7 +265,7 @@ public class WorldClient extends World {
     @Override
 	public void sendQuittingDisconnectingPacket()
     {
-        sendQueue.func_28117_a(new DisconnectPacket("Quitting"));
+        sendQueue.sendFinalPacket(new DisconnectPacket("Quitting"));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
index 86eaa9f7a..38dc54980 100644
--- a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
+++ b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
@@ -46,14 +46,14 @@ public class ChunkProviderClient
     {
     }
 
-    public void func_539_c(int i, int j)
+    public void dropChunk(int chunkX, int chunkZ)
     {
-        Chunk chunk = provideChunk(i, j);
+        Chunk chunk = provideChunk(chunkX, chunkZ);
         if(!chunk.isChunkEmpty())
         {
             chunk.onUnload();
         }
-        chunkMapping.remove(new ChunkCoordinate(i, j));
+        chunkMapping.remove(new ChunkCoordinate(chunkX, chunkZ));
         chunks.remove(chunk);
     }
 
diff --git a/src/main/java/net/minecraft/core/NextTickListEntry.java b/src/main/java/net/minecraft/core/NextTickListEntry.java
index 997d58af5..58a8b6c2b 100644
--- a/src/main/java/net/minecraft/core/NextTickListEntry.java
+++ b/src/main/java/net/minecraft/core/NextTickListEntry.java
@@ -10,11 +10,11 @@ public class NextTickListEntry
     public int z;
     public int blockId;
     public long delay;
-    private long c;
+    private final long entryId;
 
     public NextTickListEntry(int x, int y, int z, int blockId)
     {
-        c = counter++;
+        entryId = counter++;
         this.x = x;
         this.y = y;
         this.z = z;
@@ -57,10 +57,10 @@ public class NextTickListEntry
         {
             return 1;
         }
-        if(c < other.c)
+        if(entryId < other.entryId)
         {
             return -1;
         }
-        return c <= other.c ? 0 : 1;
+        return entryId <= other.entryId ? 0 : 1;
     }
 }
diff --git a/src/main/java/net/minecraft/core/achievement/Achievement.java b/src/main/java/net/minecraft/core/achievement/Achievement.java
index 9f4b14e44..c91467efe 100644
--- a/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -9,9 +9,9 @@ import net.minecraft.core.util.collection.NamespaceID;
 
 public class Achievement extends Stat
 {
-    public static final Type TYPE_NORMAL = new Type("minecraft:gui/achievement/achievement", 0xffffffff, 0xff808080, false);
-    public static final Type TYPE_SPECIAL = new Type("minecraft:gui/achievement/achievement_special", 0xffffff80, 0xff808040, false);
-    public static final Type TYPE_SECRET = new Type("minecraft:gui/achievement/achievement_secret", 0xff8080ff, 0xff404080, true);
+    public static final Type TYPE_NORMAL = new Type("minecraft:gui/screen/achievement/achievement", 0xffffffff, 0xff808080, false);
+    public static final Type TYPE_SPECIAL = new Type("minecraft:gui/screen/achievement/achievement_special", 0xffffff80, 0xff808040, false);
+    public static final Type TYPE_SECRET = new Type("minecraft:gui/screen/achievement/achievement_secret", 0xff8080ff, 0xff404080, true);
 
     public final int x;
     public final int y;
diff --git a/src/main/java/net/minecraft/core/block/AlgaeBlock.java b/src/main/java/net/minecraft/core/block/AlgaeBlock.java
index 733f29bd5..f068bce4b 100644
--- a/src/main/java/net/minecraft/core/block/AlgaeBlock.java
+++ b/src/main/java/net/minecraft/core/block/AlgaeBlock.java
@@ -6,6 +6,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
@@ -30,7 +31,7 @@ public class AlgaeBlock extends Block
     {
         if(entity instanceof BoatEntity) {
             int data = world.getBlockMetadata(x, y, z);
-            world.playBlockEvent(null, 2001, x, y, z, id);
+            world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, x, y, z, id);
             world.setBlockWithNotify(x, y, z, 0);
             this.onBlockRemoved(world, x, y, z, data);
         }
diff --git a/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java b/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
index fde1697f2..2452f1a51 100644
--- a/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
+++ b/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
@@ -15,12 +15,19 @@ public class AxisAlignedBlock extends Block {
 	}
 
 	@Override
-	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
 		Axis axis = mob.getPlacementDirection(side, PlacementMode.SIDE).getAxis();
 		
 		world.setBlockMetadataWithNotify(x, y, z, axisToMeta(axis));
 	}
 
+	@Override
+	public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+		Axis axis = side.getAxis();
+
+		world.setBlockMetadataWithNotify(x, y, z, axisToMeta(axis));
+	}
+
 	public static int axisToMeta(Axis axis) {
 		if(axis == Axis.X) return 2;
 		if(axis == Axis.Z) return 1;
diff --git a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
index 2da2ab76f..8314568e9 100644
--- a/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
@@ -186,10 +186,10 @@ public abstract class BaseLeavesBlock extends Block
         }
     }
     
-    private void removeLeaves(World world, int i, int j, int k)
+    private void removeLeaves(World world, int x, int y, int z)
     {
-        dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
-        world.setBlockWithNotify(i, j, k, 0);
+        dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+        world.setBlockWithNotify(x, y, z, 0);
     }
 
     public static boolean isPermanent(int meta) {
diff --git a/src/main/java/net/minecraft/core/block/BedBlock.java b/src/main/java/net/minecraft/core/block/BedBlock.java
index 0eb62603d..ef326abf5 100644
--- a/src/main/java/net/minecraft/core/block/BedBlock.java
+++ b/src/main/java/net/minecraft/core/block/BedBlock.java
@@ -120,7 +120,7 @@ public class BedBlock extends Block {
 
 	@Override
 	public int getPistonPushReaction(World world, int x, int y, int z) {
-		return 1;
+		return Material.PISTON_DESTROY_ON_PUSH;
 	}
 
 	public static final int MASK_IS_FOOT = 0b0000_1000;
@@ -138,14 +138,14 @@ public class BedBlock extends Block {
 		return meta & MASK_DIRECTION;
 	}
 
-	public static void setBedOccupied(World world, int i, int j, int k, boolean flag) {
-		int l = world.getBlockMetadata(i, j, k);
+	public static void setBedOccupied(World world, int x, int y, int z, boolean flag) {
+		int l = world.getBlockMetadata(x, y, z);
 		if(flag) {
 			l |= MASK_IS_OCCUPIED;
 		} else {
 			l &= ~MASK_IS_OCCUPIED;
 		}
-		world.setBlockMetadataWithNotify(i, j, k, l);
+		world.setBlockMetadataWithNotify(x, y, z, l);
 	}
 
 	public static ChunkCoordinates getNearestEmptyChunkCoordinates(World world, int x, int y, int z, int l) {
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index e362db9e7..1a2816ff9 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -555,7 +555,8 @@ public class Block
     }
 
     public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
-
+    }
+    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
     }
 
     public void onEntityWalking(World world, int x, int y, int z, Entity entity)
@@ -681,7 +682,11 @@ public class Block
         return true;
     }
 
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+        onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
+    }
+
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
 
     }
 
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index 353dacc8c..1b9dd2b76 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1208,7 +1208,7 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.CAN_HANG_OFF);
         FENCE_PAPER_WALL = new PaperWallFenceBlock("fence.paper_wall", "minecraft:block/fence_paper_wall", 891, Material.cloth).withSound(BlockSounds.CLOTH).withHardness(0.5F)
             .withTags(BlockTags.MINEABLE_BY_SHEARS, BlockTags.FENCES_CONNECT, BlockTags.CAN_HANG_OFF, BlockTags.MINEABLE_BY_AXE);
-        FENCE_STEEL = new SteelFenceBlock("fence.steel", "minecraft:block/fence_steel", 892, Material.metal).withSound(BlockSounds.METAL).withHardness(8F)
+        FENCE_STEEL = new SteelFenceBlock("fence.steel", "minecraft:block/fence_steel", 892, Material.metal).withSound(BlockSounds.METAL).withHardness(8F).withBlastResistance(2000F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.CAN_HANG_OFF);
 
         BASKET = new BasketBlock("basket", "minecraft:block/basket", 900, Material.cloth).withSound(BlockSounds.CLOTH).withHardness(0.5F).withOverrideColor(MaterialColor.wood).setStatParent(() -> Items.BASKET)
